/**
 * @file	WndBase.h
 * @brief	EBhENX̐錾уC^[tFCX̒`܂
 */

#pragma once

/**
 * @brief EBhENX
 */
class CWndBase
{
public:
	HWND m_hWnd;            /*!< must be first data member */

	CWndBase(HWND hWnd = NULL);
	CWndBase& operator=(HWND hWnd);
	void Attach(HWND hWnd);
	HWND Detach();
//	BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HWND hwndParent, HMENU nIDorHMenu);
//	BOOL DestroyWindow();

	// Attributes
	operator HWND() const;
	DWORD GetStyle() const;

	// Message Functions
	LRESULT SendMessage(UINT message, WPARAM wParam = 0, LPARAM lParam = 0);
	BOOL PostMessage(UINT message, WPARAM wParam = 0, LPARAM lParam = 0);

	// Window Text Functions
	BOOL SetWindowText(LPCTSTR lpString);
	int GetWindowText(LPTSTR lpszStringBuf, int nMaxCount) const;
	int GetWindowTextLength() const;

	// Font Functions
	void SetFont(HFONT hFont, BOOL bRedraw = TRUE);

	// Menu Functions (non-child windows only)
	HMENU GetMenu() const;
	BOOL DrawMenuBar();
	HMENU GetSystemMenu(BOOL bRevert) const;

	// Window Size and Position Functions
	void MoveWindow(int x, int y, int nWidth, int nHeight, BOOL bRepaint = TRUE);

	// Window Size and Position Functions
	BOOL GetWindowRect(LPRECT lpRect) const;
	BOOL GetClientRect(LPRECT lpRect) const;

	// Update and Painting Functions
	HDC BeginPaint(LPPAINTSTRUCT lpPaint);
	void EndPaint(LPPAINTSTRUCT lpPaint);
	BOOL UpdateWindow();
	BOOL Invalidate(BOOL bErase = TRUE);
	BOOL InvalidateRect(LPCRECT lpRect, BOOL bErase = TRUE);
	BOOL ShowWindow(int nCmdShow);

	// Window State Functions
	HWND SetFocus();

	// Misc. Operations
	int SetScrollInfo(int nBar, LPSCROLLINFO lpScrollInfo, BOOL bRedraw = TRUE);
	BOOL IsWindow() const;
};

/**
 * RXgN^
 * @param[in] hWnd EBhE nh
 */
inline CWndBase::CWndBase(HWND hWnd)
	: m_hWnd(hWnd)
{
}

/**
 * Iy[^
 * @param[in] hWnd EBhE nh
 * @return CX^X
 */
inline CWndBase& CWndBase::operator=(HWND hWnd)
{
	m_hWnd = hWnd;
	return *this;
}

/**
 * A^b`
 * @param[in] hWnd EBhE nh
 */
inline void CWndBase::Attach(HWND hWnd)
{
	m_hWnd = hWnd;
}

/**
 * f^b`
 * @return ȑÕCX^X
 */
inline HWND CWndBase::Detach()
{
	HWND hWnd = m_hWnd;
	m_hWnd = NULL;
	return hWnd;
}

/**
 * HWND Iy[^
 * @return HWND
 */
inline CWndBase::operator HWND() const
{
	return m_hWnd;
}

/**
 * ݂̃EBhE X^CԂ܂
 * @return EBhẼX^C
 */
inline DWORD CWndBase::GetStyle() const
{
	return static_cast<DWORD>(::GetWindowLong(m_hWnd, GWL_STYLE));
}

/**
 * ̃EBhEɎw肳ꂽbZ[W𑗐M܂
 * @param[in] message M郁bZ[Ww肵܂
 * @param[in] wParam ǉ̃bZ[Wˑw肵܂
 * @param[in] lParam ǉ̃bZ[Wˑw肵܂
 * @return bZ[W̏̌
 */
inline LRESULT CWndBase::SendMessage(UINT message, WPARAM wParam, LPARAM lParam)
{
	return ::SendMessage(m_hWnd, message, wParam, lParam);
}

/**
 * bZ[WEBhẼbZ[W L[ɒuAΉEBhEbZ[Ŵ҂ɕԂ܂
 * @param[in] message |Xg郁bZ[Ww肵܂
 * @param[in] wParam bZ[W̕tw肵܂
 * @param[in] lParam bZ[W̕tw肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::PostMessage(UINT message, WPARAM wParam, LPARAM lParam)
{
	return ::PostMessage(m_hWnd, message, wParam, lParam);
}

/**
 * w肳ꂽEBhẼ^Cgo[̃eLXgύX܂
 * @param[in] lpString VEBhE^Cg܂̓Rg[̃eLXgƂĎgANULL ŏI镶ւ̃|C^w肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::SetWindowText(LPCTSTR lpString)
{
	return ::SetWindowText(m_hWnd, lpString);
}

/**
 * w肳ꂽEBhẼ^Cgo[̃eLXgobt@փRs[܂
 * @param[in] lpszStringBuf obt@ւ̃|C^w肵܂B̃obt@ɃeLXgi[܂
 * @param[in] nMaxCount obt@ɃRs[镶̍ő吔w肵܂BeLXĝ̃TCY𒴂镔́A؂̂Ă܂BNULL Ɋ܂߂܂
 * @return Rs[ꂽ̕Ԃ܂ (I[ NULL ͊܂߂܂)
 */
inline int CWndBase::GetWindowText(LPTSTR lpszStringBuf, int nMaxCount) const
{
	return ::GetWindowText(m_hWnd, lpszStringBuf, nMaxCount);
}

/**
 * w肳ꂽEBhẼ^Cgo[eLXg̕Ԃ܂
 * @return ֐ƁAeLXg̕Ԃ܂
 */
inline int CWndBase::GetWindowTextLength() const
{
	return ::GetWindowTextLength(m_hWnd);
}

/**
 * w肵tHggp܂
 * @param[in] hFont tHg nh
 * @param[in] bRedraw bZ[WɃEBhEĕ`悷ꍇ TRUE
 */
inline void CWndBase::SetFont(HFONT hFont, BOOL bRedraw)
{
	::SendMessage(m_hWnd, WM_SETFONT, reinterpret_cast<WPARAM>(hFont), bRedraw);
}

/**
 * w肳ꂽEBhEɊ蓖ĂĂ郁j[̃nh擾܂
 * @return j[̃nhԂ܂
 */
inline HMENU CWndBase::GetMenu() const
{
	return ::GetMenu(m_hWnd);
}

/**
 * w肳ꂽEBhẼj[o[ĕ`悵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::DrawMenuBar()
{
	return ::DrawMenuBar(m_hWnd);
}

/**
 * w肳ꂽEBhEɊ蓖ĂĂVXe j[̃nh擾܂
 * @param[in] bRevert sANVw肵܂
 * @return j[̃nhԂ܂
 */
inline HMENU CWndBase::GetSystemMenu(BOOL bRevert) const
{
	return ::GetSystemMenu(m_hWnd, bRevert);
}

/**
 * ʒuƃTCYύX܂
 * @param[in] x ̐Vʒuw肵܂
 * @param[in] y 㑤̐Vʒuw肵܂
 * @param[in] nWidth Vw肵܂
 * @param[in] nHeight Vw肵܂
 * @param[in] bRepaint ĕ`悷Kv邩ǂw肵܂
 * @
 */
inline void CWndBase::MoveWindow(int x, int y, int nWidth, int nHeight, BOOL bRepaint)
{
	::MoveWindow(m_hWnd, x, y, nWidth, nHeight, bRepaint);
}

/**
 * w肳ꂽEBhE̍[ƉE[̍WXN[WŎ擾܂
 * @param[out] lpRect \̂ւ̃|C^w肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::GetWindowRect(LPRECT lpRect) const
{
	return ::GetWindowRect(m_hWnd, lpRect);
}

/**
 * lpRectw\ CWnd ̃NCAg̈̃NCAgWRs[܂
 * @param[out] lpRect \̂ւ̃|C^w肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::GetClientRect(LPRECT lpRect) const
{
	return ::GetClientRect(m_hWnd, lpRect);
}

/**
 * `Jn܂
 * @param[out] lpPaint `ւ̃|C^w肵܂
 * @return foCX ReLXg
 */
inline HDC CWndBase::BeginPaint(LPPAINTSTRUCT lpPaint)
{
	return ::BeginPaint(m_hWnd, lpPaint);
}

/**
 * `̏I܂
 * @param[in] lpPaint `ւ̃|C^w肵܂
 */
inline void CWndBase::EndPaint(LPPAINTSTRUCT lpPaint)
{
	::EndPaint(m_hWnd, lpPaint);
}

/**
 * w肳ꂽEBhE̍XV[Wł͂ȂꍇAEBhE bZ[W𑗐MÃEBhẼNCAg̈XV܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::UpdateWindow()
{
	return ::UpdateWindow(m_hWnd);
}

/**
 * w肳ꂽEBhÊׂĂXV[Wɂ܂
 * @param[in] bErase XV[WƂɁAXV[W̔wi邩ǂw肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::Invalidate(BOOL bErase)
{
	return ::InvalidateRect(m_hWnd, NULL, bErase);
}

/**
 * w肳ꂽEBhE̍XV[W1̒`ǉ܂
 * @param[in] lpRect XV[W֒ǉ`̃NCAgWێ1̍\̂ւ̃|C^w肵܂
 * @param[in] bErase XV[WƂɁAXV[W̔wi邩ǂw肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::InvalidateRect(LPCRECT lpRect, BOOL bErase)
{
	return ::InvalidateRect(m_hWnd, lpRect, bErase);
}

/**
 * w肳ꂽEBhE̕\Ԃݒ肵܂
 * @param[in] nCmdShow EBhE̕\@w肵܂
 * @retval TRUE 
 * @retval FALSE s
 */
inline BOOL CWndBase::ShowWindow(int nCmdShow)
{
	return ::ShowWindow(m_hWnd, nCmdShow);
}

/**
 * ̓tH[JXv܂
 * @return Oɓ̓tH[JXĂEBhE nh
 */
inline HWND CWndBase::SetFocus()
{
	return ::SetFocus(m_hWnd);
}

/**
 * XN[o[̂܂܂ȃp[^ݒ肵܂
 * @param[in] nBar p[^ݒ肷ׂXN[o[̃^Cvw肵܂
 * @param[in] lpScrollInfo ݒ肷ׂێĂA1̍\̂ւ̃|C^w肵܂
 * @param[in] bRedraw XN[o[ĕ`悷邩ǂw肵܂
 * @return XN[o[݂̌̃XN[ʒuԂ܂
 */
inline int CWndBase::SetScrollInfo(int nBar, LPSCROLLINFO lpScrollInfo, BOOL bRedraw)
{
	return ::SetScrollInfo(m_hWnd, nBar, lpScrollInfo, bRedraw);
}

/**
 * EBhE݂Ă邩ǂ𒲂ׂ܂
 * @return w肵EBhEnhEBhE݂Ăꍇ́A0 ȊO̒lԂ܂
 */
inline BOOL CWndBase::IsWindow() const
{
	return ::IsWindow(m_hWnd);
}
